<?php
 class elFinderVolumeFTP extends elFinderVolumeDriver {
 protected $driverId = 'f';
 protected $connect = null;
 protected $tmpPath = '';
 protected $ftpError = '';
 protected $ftpOsUnix;
 protected $ftpListOption = '-al';
 protected $isPureFtpd = false;
 protected $isFTPS = false;
 protected $tmp = '';
 private $MLSTsupprt = false;
 private $cacheDirTarget = '';
 public function __construct() {
 $opts = array( 'host' => 'localhost', 'user' => '', 'pass' => '', 'port' => 21, 'mode' => 'passive', 'ssl' => false, 'path' => '/', 'timeout' => 20, 'owner' => true, 'tmbPath' => '', 'tmpPath' => '', 'separator' => '/', 'dirMode' => 0755, 'fileMode' => 0644, 'rootCssClass' => 'elfinder-navbar-root-ftp', 'ftpListOption' => '-al', );
 $this->options = array_merge($this->options, $opts);
 $this->options['mimeDetect'] = 'internal';
 }
 public function netmountPrepare($options) {
 if (!empty($_REQUEST['encoding']) && iconv('UTF-8', $_REQUEST['encoding'], '') !== false) {
 $options['encoding'] = $_REQUEST['encoding'];
 if (!empty($_REQUEST['locale']) && setlocale(LC_ALL, $_REQUEST['locale'])) {
 setlocale(LC_ALL, elFinder::$locale);
 $options['locale'] = $_REQUEST['locale'];
 }
 }
 if (!empty($_REQUEST['FTPS'])) {
 $options['ssl'] = true;
 }
 $options['statOwner'] = true;
 $options['allowChmodReadOnly'] = true;
 $options['acceptedName'] = '#^[^/\\?*:|"<>]*[^./\\?*:|"<>]$#';
 return $options;
 }
 protected function init() {
 if (!$this->options['host'] || !$this->options['port']) {
 return $this->setError('Required options undefined.');
 }
 if (!$this->options['user']) {
 $this->options['user'] = 'anonymous';
 $this->options['pass'] = '';
 }
 if (!$this->options['path']) {
 $this->options['path'] = '/';
 }
 $this->netMountKey = md5(join('-', array('ftp', $this->options['host'], $this->options['port'], $this->options['path'], $this->options['user'])));
 if (!function_exists('ftp_connect')) {
 return $this->setError('FTP extension not loaded.');
 }
 $scheme = parse_url($this->options['host'], PHP_URL_SCHEME);
 if ($scheme) {
 $this->options['host'] = substr($this->options['host'], strlen($scheme) + 3);
 }
 $this->root = $this->options['path'] = $this->_normpath($this->options['path']);
 if (empty($this->options['alias'])) {
 $this->options['alias'] = $this->options['user'] . '@' . $this->options['host'];
 }
 $this->rootName = $this->options['alias'];
 $this->options['separator'] = '/';
 if (is_null($this->options['syncChkAsTs'])) {
 $this->options['syncChkAsTs'] = true;
 }
 if (isset($this->options['ftpListOption'])) {
 $this->ftpListOption = $this->options['ftpListOption'];
 }
 return $this->connect();
 }
 protected function configure() {
 parent::configure();
 if (!empty($this->options['tmpPath'])) {
 if ((is_dir($this->options['tmpPath']) || mkdir($this->options['tmpPath'], 0755, true)) && is_writable($this->options['tmpPath'])) {
 $this->tmp = $this->options['tmpPath'];
 }
 }
 if (!$this->tmp && ($tmp = elFinder::getStaticVar('commonTempPath'))) {
 $this->tmp = $tmp;
 }
 if (!$this->tmp && $this->tmbPathWritable) {
 $this->tmp = $this->tmbPath;
 }
 if (!$this->tmp) {
 $this->disabled[] = 'mkfile';
 $this->disabled[] = 'paste';
 $this->disabled[] = 'duplicate';
 $this->disabled[] = 'upload';
 $this->disabled[] = 'edit';
 $this->disabled[] = 'archive';
 $this->disabled[] = 'extract';
 }
 }
 protected function connect() {
 $withSSL = empty($this->options['ssl']) ? '' : ' with SSL';
 if ($withSSL) {
 if (!function_exists('ftp_ssl_connect') || !($this->connect = ftp_ssl_connect($this->options['host'], $this->options['port'], $this->options['timeout']))) {
 return $this->setError('Unable to connect to FTP server ' . $this->options['host'] . $withSSL);
 }
 $this->isFTPS = true;
 }
 else {
 if (!($this->connect = ftp_connect($this->options['host'], $this->options['port'], $this->options['timeout']))) {
 return $this->setError('Unable to connect to FTP server ' . $this->options['host']);
 }
 }
 if (!ftp_login($this->connect, $this->options['user'], $this->options['pass'])) {
 $this->umount();
 return $this->setError('Unable to login into ' . $this->options['host'] . $withSSL);
 }
 if ($this->encoding) {
 ftp_raw($this->connect, 'OPTS UTF8 OFF');
 }
 else {
 ftp_raw($this->connect, 'OPTS UTF8 ON');
 }
 $help = ftp_raw($this->connect, 'HELP');
 $this->isPureFtpd = stripos(implode(' ', $help), 'Pure-FTPd') !== false;
 if (!$this->isPureFtpd) {
 ftp_raw($this->connect, 'epsv4 off');
 }
 $pasv = ($this->options['mode'] == 'passive');
 if (!ftp_pasv($this->connect, $pasv)) {
 if ($pasv) {
 $this->options['mode'] = 'active';
 }
 }
 if (!ftp_chdir($this->connect, $this->root) || $this->root != ftp_pwd($this->connect)) {
 $this->umount();
 return $this->setError('Unable to open root folder.');
 }
 $features = ftp_raw($this->connect, 'FEAT');
 if (!is_array($features)) {
 $this->umount();
 return $this->setError('Server does not support command FEAT.');
 }
 foreach ($features as $feat) {
 if (strpos(trim($feat), 'MLST') === 0) {
 $this->MLSTsupprt = true;
 break;
 }
 }
 return true;
 }
 protected function ftpRawList($path) {
 if ($this->isPureFtpd) {
 $path = str_replace(' ', '\ ', $path);
 }
 if ($this->ftpListOption) {
 $path = $this->ftpListOption . ' ' . $path;
 }
 $res = ftp_rawlist($this->connect, $path);
 if ($res === false) {
 $res = array();
 }
 return $res;
 }
 public function umount() {
 $this->connect && ftp_close($this->connect);
 }
 protected function parseRaw($raw, $base, $nameOnly = false) {
 static $now;
 static $lastyear;
 if (!$now) {
 $now = time();
 $lastyear = date('Y') - 1;
 }
 $info = preg_split("/\s+/", $raw, 9);
 $stat = array();
 if (!isset($this->ftpOsUnix)) {
 $this->ftpOsUnix = !preg_match('/\d/', substr($info[0], 0, 1));
 }
 if (!$this->ftpOsUnix) {
 $info = $this->normalizeRawWindows($raw);
 }
 if (count($info) < 9 || $info[8] == '.' || $info[8] == '..') {
 return false;
 }
 $name = $info[8];
 if (preg_match('|(.+)\-\>(.+)|', $name, $m)) {
 $name = trim($m[1]);
 if ($this->cacheDirTarget && $this->_joinPath($base, $name) !== $this->cacheDirTarget) {
 return array();
 }
 if (!$nameOnly) {
 $target = trim($m[2]);
 if (substr($target, 0, 1) !== $this->separator) {
 $target = $this->getFullPath($target, $base);
 }
 $target = $this->_normpath($target);
 $stat['name'] = $name;
 $stat['target'] = $target;
 return $stat;
 }
 }
 if ($nameOnly) {
 return array('name' => $name);
 }
 if (is_numeric($info[5]) && !$info[6] && !$info[7]) {
 $stat['ts'] = $info[5];
 }
 else {
 $stat['ts'] = strtotime($info[5] . ' ' . $info[6] . ' ' . $info[7]);
 if ($stat['ts'] && $stat['ts'] > $now && strpos($info[7], ':') !== false) {
 $stat['ts'] = strtotime($info[5] . ' ' . $info[6] . ' ' . $lastyear . ' ' . $info[7]);
 }
 if (empty($stat['ts'])) {
 $stat['ts'] = strtotime($info[6] . ' ' . $info[5] . ' ' . $info[7]);
 if ($stat['ts'] && $stat['ts'] > $now && strpos($info[7], ':') !== false) {
 $stat['ts'] = strtotime($info[6] . ' ' . $info[5] . ' ' . $lastyear . ' ' . $info[7]);
 }
 }
 }
 if ($this->options['statOwner']) {
 $stat['owner'] = $info[2];
 $stat['group'] = $info[3];
 $stat['perm'] = substr($info[0], 1);
 $stat['isowner'] = isset($stat['owner']) ? ($this->options['owner'] ? true : ($stat['owner'] == $this->options['user'])) : true;
 }
 $owner_computed = isset($stat['isowner']) ? $stat['isowner'] : $this->options['owner'];
 $perm = $this->parsePermissions($info[0], $owner_computed);
 $stat['name'] = $name;
 $stat['mime'] = substr(strtolower($info[0]), 0, 1) == 'd' ? 'directory' : $this->mimetype($stat['name'], true);
 $stat['size'] = $stat['mime'] == 'directory' ? 0 : $info[4];
 $stat['read'] = $perm['read'];
 $stat['write'] = $perm['write'];
 return $stat;
 }
 protected function normalizeRawWindows($raw) {
 $info = array_pad(array(), 9, '');
 $item = preg_replace('#\s+#', ' ', trim($raw), 3);
 list($date, $time, $size, $name) = explode(' ', $item, 4);
 $format = strlen($date) === 8 ? 'm-d-yH:iA' : 'Y-m-dH:i';
 $dateObj = DateTime::createFromFormat($format, $date . $time);
 $info[5] = strtotime($dateObj->format('Y-m-d H:i'));
 $info[8] = $name;
 if ($size === '<DIR>') {
 $info[4] = 0;
 $info[0] = 'drwxr-xr-x';
 }
 else {
 $info[4] = (int)$size;
 $info[0] = '-rw-r--r--';
 }
 return $info;
 }
 protected function parsePermissions($perm, $isowner = true) {
 $res = array();
 $parts = array();
 for ($i = 0, $l = strlen($perm);
 $i < $l;
 $i++) {
 $parts[] = substr($perm, $i, 1);
 }
 $read = ($isowner && $parts[1] == 'r') || $parts[4] == 'r' || $parts[7] == 'r';
 return array( 'read' => $parts[0] == 'd' ? $read && (($isowner && $parts[3] == 'x') || $parts[6] == 'x' || $parts[9] == 'x') : $read, 'write' => ($isowner && $parts[2] == 'w') || $parts[5] == 'w' || $parts[8] == 'w' );
 }
 protected function cacheDir($path) {
 $this->dirsCache[$path] = array();
 $hasDir = false;
 $list = array();
 $encPath = $this->convEncIn($path);
 foreach ($this->ftpRawList($encPath) as $raw) {
 if (($stat = $this->parseRaw($raw, $encPath))) {
 $list[] = $stat;
 }
 }
 $list = $this->convEncOut($list);
 $prefix = ($path === $this->separator) ? $this->separator : $path . $this->separator;
 $targets = array();
 foreach ($list as $stat) {
 $p = $prefix . $stat['name'];
 if (isset($stat['target'])) {
 $targets[$stat['name']] = $stat['target'];
 }
 else {
 $stat = $this->updateCache($p, $stat);
 if (empty($stat['hidden'])) {
 if (!$hasDir && $stat['mime'] === 'directory') {
 $hasDir = true;
 }
 $this->dirsCache[$path][] = $p;
 }
 }
 }
 foreach ($targets as $name => $target) {
 $stat = array();
 $stat['name'] = $name;
 $p = $prefix . $name;
 $cacheDirTarget = $this->cacheDirTarget;
 $this->cacheDirTarget = $this->convEncIn($target, true);
 if ($tstat = $this->stat($target)) {
 $stat['size'] = $tstat['size'];
 $stat['alias'] = $target;
 $stat['thash'] = $tstat['hash'];
 $stat['mime'] = $tstat['mime'];
 $stat['read'] = $tstat['read'];
 $stat['write'] = $tstat['write'];
 if (isset($tstat['ts'])) {
 $stat['ts'] = $tstat['ts'];
 }
 if (isset($tstat['owner'])) {
 $stat['owner'] = $tstat['owner'];
 }
 if (isset($tstat['group'])) {
 $stat['group'] = $tstat['group'];
 }
 if (isset($tstat['perm'])) {
 $stat['perm'] = $tstat['perm'];
 }
 if (isset($tstat['isowner'])) {
 $stat['isowner'] = $tstat['isowner'];
 }
 }
 else {
 $stat['mime'] = 'symlink-broken';
 $stat['read'] = false;
 $stat['write'] = false;
 $stat['size'] = 0;
 }
 $this->cacheDirTarget = $cacheDirTarget;
 $stat = $this->updateCache($p, $stat);
 if (empty($stat['hidden'])) {
 if (!$hasDir && $stat['mime'] === 'directory') {
 $hasDir = true;
 }
 $this->dirsCache[$path][] = $p;
 }
 }
 if (isset($this->sessionCache['subdirs'])) {
 $this->sessionCache['subdirs'][$path] = $hasDir;
 }
 }
 protected function ftpMode($path) {
 return strpos($this->mimetype($path), 'text/') === 0 ? FTP_ASCII : FTP_BINARY;
 }
 protected function _dirname($path) {
 $parts = explode($this->separator, trim($path, $this->separator));
 array_pop($parts);
 return $this->separator . join($this->separator, $parts);
 }
 protected function _basename($path) {
 $parts = explode($this->separator, trim($path, $this->separator));
 return array_pop($parts);
 }
 protected function _joinPath($dir, $name) {
 return rtrim($dir, $this->separator) . $this->separator . $name;
 }
 protected function _normpath($path) {
 if (empty($path)) {
 $path = '.';
 }
 $path = preg_replace('|^\.\/?|', $this->separator, $path);
 $path = preg_replace('/^([^\/])/', "/$1", $path);
 if ($path[0] === $this->separator) {
 $initial_slashes = true;
 }
 else {
 $initial_slashes = false;
 }
 if (($initial_slashes) && (strpos($path, '//') === 0) && (strpos($path, '///') === false)) {
 $initial_slashes = 2;
 }
 $initial_slashes = (int)$initial_slashes;
 $comps = explode($this->separator, $path);
 $new_comps = array();
 foreach ($comps as $comp) {
 if (in_array($comp, array('', '.'))) {
 continue;
 }
 if (($comp != '..') || (!$initial_slashes && !$new_comps) || ($new_comps && (end($new_comps) == '..'))) {
 array_push($new_comps, $comp);
 }
 elseif ($new_comps) {
 array_pop($new_comps);
 }
 }
 $comps = $new_comps;
 $path = implode($this->separator, $comps);
 if ($initial_slashes) {
 $path = str_repeat($this->separator, $initial_slashes) . $path;
 }
 return $path ? $path : '.';
 }
 protected function _relpath($path) {
 if ($path === $this->root) {
 return '';
 }
 else {
 if (strpos($path, $this->root) === 0) {
 return ltrim(substr($path, strlen($this->root)), $this->separator);
 }
 else {
 return $path;
 }
 }
 }
 protected function _abspath($path) {
 if ($path === $this->separator) {
 return $this->root;
 }
 else {
 if ($path[0] === $this->separator) {
 return $path;
 }
 else {
 return $this->_joinPath($this->root, $path);
 }
 }
 }
 protected function _path($path) {
 return $this->rootName . ($path == $this->root ? '' : $this->separator . $this->_relpath($path));
 }
 protected function _inpath($path, $parent) {
 return $path == $parent || strpos($path, rtrim($parent, $this->separator) . $this->separator) === 0;
 }
 protected function _stat($path) {
 $outPath = $this->convEncOut($path);
 if (isset($this->cache[$outPath])) {
 return $this->convEncIn($this->cache[$outPath]);
 }
 else {
 $this->convEncIn();
 }
 if (!$this->MLSTsupprt) {
 if ($path === $this->root) {
 $res = array( 'name' => $this->root, 'mime' => 'directory', 'dirs' => $this->_subdirs($path) );
 if ($this->isMyReload()) {
 $ts = 0;
 foreach ($this->ftpRawList($path) as $str) {
 if (($stat = $this->parseRaw($str, $path))) {
 if (!empty($stat['ts'])) {
 $ts = max($ts, $stat['ts']);
 }
 }
 }
 if ($ts) {
 $res['ts'] = $ts;
 }
 }
 return $res;
 }
 if ($path === $this->separator) {
 $res = array( 'name' => $this->separator, 'mime' => 'directory', 'dirs' => 1 );
 $this->cache[$outPath] = $res;
 return $res;
 }
 $pPath = $this->_dirname($path);
 if ($this->_inPath($pPath, $this->root)) {
 $outPPpath = $this->convEncOut($pPath);
 if (!isset($this->dirsCache[$outPPpath])) {
 $parentSubdirs = null;
 if (isset($this->sessionCache['subdirs']) && isset($this->sessionCache['subdirs'][$outPPpath])) {
 $parentSubdirs = $this->sessionCache['subdirs'][$outPPpath];
 }
 $this->cacheDir($outPPpath);
 if ($parentSubdirs) {
 $this->sessionCache['subdirs'][$outPPpath] = $parentSubdirs;
 }
 }
 }
 $stat = $this->convEncIn(isset($this->cache[$outPath]) ? $this->cache[$outPath] : array());
 if (!$this->mounted) {
 $this->cache = array();
 }
 return $stat;
 }
 $raw = ftp_raw($this->connect, 'MLST ' . $path);
 if (is_array($raw) && count($raw) > 1 && substr(trim($raw[0]), 0, 1) == 2) {
 $parts = explode(';', trim($raw[1]));
 array_pop($parts);
 $parts = array_map('strtolower', $parts);
 $stat = array();
 $mode = '';
 foreach ($parts as $part) {
 list($key, $val) = explode('=', $part, 2);
 switch ($key) {
 case 'type': if (strpos($val, 'dir') !== false) {
 $stat['mime'] = 'directory';
 }
 else if (strpos($val, 'link') !== false) {
 $stat['mime'] = 'symlink';
 break(2);
 }
 else {
 $stat['mime'] = $this->mimetype($path);
 }
 break;
 case 'size': $stat['size'] = $val;
 break;
 case 'modify': $ts = mktime(intval(substr($val, 8, 2)), intval(substr($val, 10, 2)), intval(substr($val, 12, 2)), intval(substr($val, 4, 2)), intval(substr($val, 6, 2)), substr($val, 0, 4));
 $stat['ts'] = $ts;
 break;
 case 'unix.mode': $mode = strval($val);
 break;
 case 'unix.uid': $stat['owner'] = $val;
 break;
 case 'unix.gid': $stat['group'] = $val;
 break;
 case 'perm': $val = strtolower($val);
 $stat['read'] = (int)preg_match('/e|l|r/', $val);
 $stat['write'] = (int)preg_match('/w|m|c/', $val);
 if (!preg_match('/f|d/', $val)) {
 $stat['locked'] = 1;
 }
 break;
 }
 }
 if (empty($stat['mime'])) {
 return array();
 }
 if ($stat['mime'] === 'symlink') {
 $this->MLSTsupprt = false;
 $res = $this->_stat($path);
 $this->MLSTsupprt = true;
 return $res;
 }
 if ($stat['mime'] === 'directory') {
 $stat['size'] = 0;
 }
 if ($mode) {
 $stat['perm'] = '';
 if ($mode[0] === '0') {
 $mode = substr($mode, 1);
 }
 $perm = array();
 for ($i = 0;
 $i <= 2;
 $i++) {
 $perm[$i] = array(false, false, false);
 $n = isset($mode[$i]) ? $mode[$i] : 0;
 if ($n - 4 >= 0) {
 $perm[$i][0] = true;
 $n = $n - 4;
 $stat['perm'] .= 'r';
 }
 else {
 $stat['perm'] .= '-';
 }
 if ($n - 2 >= 0) {
 $perm[$i][1] = true;
 $n = $n - 2;
 $stat['perm'] .= 'w';
 }
 else {
 $stat['perm'] .= '-';
 }
 if ($n - 1 == 0) {
 $perm[$i][2] = true;
 $stat['perm'] .= 'x';
 }
 else {
 $stat['perm'] .= '-';
 }
 }
 $stat['perm'] = trim($stat['perm']);
 $owner_computed = isset($stat['owner']) ? ($this->options['owner'] ? true : ($stat['owner'] == $this->options['user'])) : true;
 $read = ($owner_computed && $perm[0][0]) || $perm[1][0] || $perm[2][0];
 $stat['read'] = $stat['mime'] == 'directory' ? $read && (($owner_computed && $perm[0][2]) || $perm[1][2] || $perm[2][2]) : $read;
 $stat['write'] = ($owner_computed && $perm[0][1]) || $perm[1][1] || $perm[2][1];
 if ($this->options['statOwner']) {
 $stat['isowner'] = $owner_computed;
 }
 else {
 unset($stat['owner'], $stat['group'], $stat['perm']);
 }
 }
 return $stat;
 }
 return array();
 }
 protected function _subdirs($path) {
 foreach ($this->ftpRawList($path) as $str) {
 $info = preg_split('/\s+/', $str, 9);
 if (!isset($this->ftpOsUnix)) {
 $this->ftpOsUnix = !preg_match('/\d/', substr($info[0], 0, 1));
 }
 if (!$this->ftpOsUnix) {
 $info = $this->normalizeRawWindows($str);
 }
 $name = isset($info[8]) ? trim($info[8]) : '';
 if ($name && $name !== '.' && $name !== '..' && substr(strtolower($info[0]), 0, 1) === 'd') {
 return true;
 }
 }
 return false;
 }
 protected function _dimensions($path, $mime) {
 $ret = false;
 if ($imgsize = $this->getImageSize($path, $mime)) {
 $ret = array('dim' => $imgsize['dimensions']);
 if (!empty($imgsize['url'])) {
 $ret['url'] = $imgsize['url'];
 }
 }
 return $ret;
 }
 protected function _scandir($path) {
 $files = array();
 foreach ($this->ftpRawList($path) as $str) {
 if (($stat = $this->parseRaw($str, $path, true))) {
 $files[] = $this->_joinPath($path, $stat['name']);
 }
 }
 return $files;
 }
 protected function _fopen($path, $mode = 'rb') {
 if ($this->options['mode'] === 'passive' && ini_get('allow_url_fopen')) {
 $url = ($this->isFTPS ? 'ftps' : 'ftp') . '://' . $this->options['user'] . ':' . $this->options['pass'] . '@' . $this->options['host'] . ':' . $this->options['port'] . $path;
 if (strtolower($mode[0]) === 'w') {
 $context = stream_context_create(array('ftp' => array('overwrite' => true)));
 $fp = fopen($url, $mode, false, $context);
 }
 else {
 $fp = fopen($url, $mode);
 }
 if ($fp) {
 return $fp;
 }
 }
 if ($this->tmp) {
 $local = $this->getTempFile($path);
 $fp = fopen($local, 'wb');
 $ret = ftp_nb_fget($this->connect, $fp, $path, FTP_BINARY);
 while ($ret === FTP_MOREDATA) {
 elFinder::extendTimeLimit();
 $ret = ftp_nb_continue($this->connect);
 }
 if ($ret === FTP_FINISHED) {
 fclose($fp);
 $fp = fopen($local, $mode);
 return $fp;
 }
 fclose($fp);
 is_file($local) && unlink($local);
 }
 return false;
 }
 protected function _fclose($fp, $path = '') {
 is_resource($fp) && fclose($fp);
 if ($path) {
 unlink($this->getTempFile($path));
 }
 }
 protected function _mkdir($path, $name) {
 $path = $this->_joinPath($path, $name);
 if (ftp_mkdir($this->connect, $path) === false) {
 return false;
 }
 $this->options['dirMode'] && ftp_chmod($this->connect, $this->options['dirMode'], $path);
 return $path;
 }
 protected function _mkfile($path, $name) {
 if ($this->tmp) {
 $path = $this->_joinPath($path, $name);
 $local = $this->getTempFile();
 $res = touch($local) && ftp_put($this->connect, $path, $local, FTP_ASCII);
 unlink($local);
 return $res ? $path : false;
 }
 return false;
 }
 protected function _symlink($target, $path, $name) {
 return false;
 }
 protected function _copy($source, $targetDir, $name) {
 $res = false;
 if ($this->tmp) {
 $local = $this->getTempFile();
 $target = $this->_joinPath($targetDir, $name);
 if (ftp_get($this->connect, $local, $source, FTP_BINARY) && ftp_put($this->connect, $target, $local, $this->ftpMode($target))) {
 $res = $target;
 }
 unlink($local);
 }
 return $res;
 }
 protected function _move($source, $targetDir, $name) {
 $target = $this->_joinPath($targetDir, $name);
 return ftp_rename($this->connect, $source, $target) ? $target : false;
 }
 protected function _unlink($path) {
 return ftp_delete($this->connect, $path);
 }
 protected function _rmdir($path) {
 return ftp_rmdir($this->connect, $path);
 }
 protected function _save($fp, $dir, $name, $stat) {
 $path = $this->_joinPath($dir, $name);
 return ftp_fput($this->connect, $path, $fp, $this->ftpMode($path)) ? $path : false;
 }
 protected function _getContents($path) {
 $contents = '';
 if (($fp = $this->_fopen($path))) {
 while (!feof($fp)) {
 $contents .= fread($fp, 8192);
 }
 $this->_fclose($fp, $path);
 return $contents;
 }
 return false;
 }
 protected function _filePutContents($path, $content) {
 $res = false;
 if ($this->tmp) {
 $local = $this->getTempFile();
 if (file_put_contents($local, $content, LOCK_EX) !== false && ($fp = fopen($local, 'rb'))) {
 $file = $this->stat($this->convEncOut($path, false));
 if (!empty($file['thash'])) {
 $path = $this->decode($file['thash']);
 }
 clearstatcache();
 $res = ftp_fput($this->connect, $path, $fp, $this->ftpMode($path));
 fclose($fp);
 }
 file_exists($local) && unlink($local);
 }
 return $res;
 }
 protected function _checkArchivers() {
 $this->archivers = $this->getArchivers();
 return;
 }
 protected function _chmod($path, $mode) {
 $modeOct = is_string($mode) ? octdec($mode) : octdec(sprintf("%04o", $mode));
 return ftp_chmod($this->connect, $modeOct, $path);
 }
 protected function _extract($path, $arc) {
 $dir = $this->tempDir();
 if (!$dir) {
 return false;
 }
 $basename = $this->_basename($path);
 $localPath = $dir . DIRECTORY_SEPARATOR . $basename;
 if (!ftp_get($this->connect, $localPath, $path, FTP_BINARY)) {
 $this->rmdirRecursive($dir);
 return false;
 }
 $this->unpackArchive($localPath, $arc);
 $this->archiveSize = 0;
 $checkRes = $this->checkExtractItems($dir);
 if ($checkRes['symlinks']) {
 $this->rmdirRecursive($dir);
 return $this->setError(array_merge($this->error, array(elFinder::ERROR_ARC_SYMLINKS)));
 }
 $this->archiveSize = $checkRes['totalSize'];
 if ($checkRes['rmNames']) {
 foreach ($checkRes['rmNames'] as $name) {
 $this->addError(elFinder::ERROR_SAVE, $name);
 }
 }
 $filesToProcess = self::listFilesInDirectory($dir, true);
 if (empty($filesToProcess)) {
 $this->rmdirRecursive($dir);
 return false;
 }
 if ($this->options['maxArcFilesSize'] > 0 && $this->options['maxArcFilesSize'] < $this->archiveSize) {
 $this->rmdirRecursive($dir);
 return $this->setError(elFinder::ERROR_ARC_MAXSIZE);
 }
 $extractTo = $this->extractToNewdir;
 $name = '';
 $src = $dir . DIRECTORY_SEPARATOR . $filesToProcess[0];
 if (($extractTo === 'auto' || !$extractTo) && count($filesToProcess) === 1 && is_file($src)) {
 $name = $filesToProcess[0];
 }
 else if ($extractTo === 'auto' || $extractTo) {
 $src = $dir;
 $splits = elFinder::splitFileExtention(basename($path));
 $name = $splits[0];
 $test = $this->_joinPath(dirname($path), $name);
 if ($this->stat($test)) {
 $name = $this->uniqueName(dirname($path), $name, '-', false);
 }
 }
 if ($name !== '' && is_file($src)) {
 $result = $this->_joinPath(dirname($path), $name);
 if (!ftp_put($this->connect, $result, $src, FTP_BINARY)) {
 $this->rmdirRecursive($dir);
 return false;
 }
 }
 else {
 $dstDir = $this->_dirname($path);
 $result = array();
 if (is_dir($src) && $name) {
 $target = $this->_joinPath($dstDir, $name);
 $_stat = $this->_stat($target);
 if ($_stat) {
 if (!$this->options['copyJoin']) {
 if ($_stat['mime'] === 'directory') {
 $this->delTree($target);
 }
 else {
 $this->_unlink($target);
 }
 $_stat = false;
 }
 else {
 $dstDir = $target;
 }
 }
 if (!$_stat && (!$dstDir = $this->_mkdir($dstDir, $name))) {
 $this->rmdirRecursive($dir);
 return false;
 }
 $result[] = $dstDir;
 }
 foreach ($filesToProcess as $name) {
 $name = rtrim($name, DIRECTORY_SEPARATOR);
 $src = $dir . DIRECTORY_SEPARATOR . $name;
 if (is_dir($src)) {
 $p = dirname($name);
 if ($p === '.') {
 $p = '';
 }
 $name = basename($name);
 $target = $this->_joinPath($this->_joinPath($dstDir, $p), $name);
 $_stat = $this->_stat($target);
 if ($_stat) {
 if (!$this->options['copyJoin']) {
 if ($_stat['mime'] === 'directory') {
 $this->delTree($target);
 }
 else {
 $this->_unlink($target);
 }
 $_stat = false;
 }
 }
 if (!$_stat && (!$target = $this->_mkdir($this->_joinPath($dstDir, $p), $name))) {
 $this->rmdirRecursive($dir);
 return false;
 }
 }
 else {
 $target = $this->_joinPath($dstDir, $name);
 if (!ftp_put($this->connect, $target, $src, FTP_BINARY)) {
 $this->rmdirRecursive($dir);
 return false;
 }
 }
 $result[] = $target;
 }
 if (!$result) {
 $this->rmdirRecursive($dir);
 return false;
 }
 }
 is_dir($dir) && $this->rmdirRecursive($dir);
 $this->clearcache();
 return $result ? $result : false;
 }
 protected function _archive($dir, $files, $name, $arc) {
 $cwd = getcwd();
 $tmpDir = $this->tempDir();
 if (!$tmpDir) {
 return false;
 }
 if (!$this->ftp_download_files($dir, $files, $tmpDir)) {
 $this->rmdirRecursive($tmpDir);
 return false;
 }
 $remoteArchiveFile = false;
 if ($path = $this->makeArchive($tmpDir, $files, $name, $arc)) {
 $remoteArchiveFile = $this->_joinPath($dir, $name);
 if (!ftp_put($this->connect, $remoteArchiveFile, $path, FTP_BINARY)) {
 $remoteArchiveFile = false;
 }
 }
 if (!$this->rmdirRecursive($tmpDir)) {
 return false;
 }
 return $remoteArchiveFile;
 }
 private function tempDir() {
 $tempPath = tempnam($this->tmp, 'elFinder');
 if (!$tempPath) {
 $this->setError(elFinder::ERROR_CREATING_TEMP_DIR, $this->tmp);
 return false;
 }
 $success = unlink($tempPath);
 if (!$success) {
 $this->setError(elFinder::ERROR_CREATING_TEMP_DIR, $this->tmp);
 return false;
 }
 $success = mkdir($tempPath, 0700, true);
 if (!$success) {
 $this->setError(elFinder::ERROR_CREATING_TEMP_DIR, $this->tmp);
 return false;
 }
 return $tempPath;
 }
 protected function ftp_scan_dir($remote_directory, $targets = null) {
 $buff = $this->ftpRawList($remote_directory);
 $items = array();
 if ($targets && is_array($targets)) {
 $targets = array_flip($targets);
 }
 else {
 $targets = false;
 }
 foreach ($buff as $str) {
 $info = preg_split("/\s+/", $str, 9);
 if (!isset($this->ftpOsUnix)) {
 $this->ftpOsUnix = !preg_match('/\d/', substr($info[0], 0, 1));
 }
 if (!$this->ftpOsUnix) {
 $info = $this->normalizeRawWindows($str);
 }
 $type = substr($info[0], 0, 1);
 $name = trim($info[8]);
 if ($name !== '.' && $name !== '..' && (!$targets || isset($targets[$name]))) {
 switch ($type) {
 case 'l' : case 'd' : $remote_file_path = $this->_joinPath($remote_directory, $name);
 $item = array();
 $item['path'] = $remote_file_path;
 $item['type'] = 'd';
 $items[] = $item;
 $items = array_merge($items, $this->ftp_scan_dir($remote_file_path));
 break;
 default: $remote_file_path = $this->_joinPath($remote_directory, $name);
 $item = array();
 $item['path'] = $remote_file_path;
 $item['type'] = 'f';
 $items[] = $item;
 }
 }
 }
 return $items;
 }
 private function ftp_download_files($remote_directory, array $files, $dest_local_directory) {
 $contents = $this->ftp_scan_dir($remote_directory, $files);
 if (!isset($contents)) {
 $this->setError(elFinder::ERROR_FTP_DOWNLOAD_FILE, $remote_directory);
 return false;
 }
 $remoteDirLen = strlen($remote_directory);
 foreach ($contents as $item) {
 $relative_path = substr($item['path'], $remoteDirLen);
 $local_path = $dest_local_directory . DIRECTORY_SEPARATOR . $relative_path;
 switch ($item['type']) {
 case 'd': $success = mkdir($local_path);
 break;
 case 'f': $success = ftp_get($this->connect, $local_path, $item['path'], FTP_BINARY);
 break;
 default: $success = true;
 }
 if (!$success) {
 $this->setError(elFinder::ERROR_FTP_DOWNLOAD_FILE, $remote_directory);
 return false;
 }
 }
 return true;
 }
 private function deleteDir($dirPath) {
 if (!is_dir($dirPath)) {
 $success = unlink($dirPath);
 }
 else {
 $success = true;
 foreach (array_reverse(elFinderVolumeFTP::listFilesInDirectory($dirPath, false)) as $path) {
 $path = $dirPath . DIRECTORY_SEPARATOR . $path;
 if (is_link($path)) {
 unlink($path);
 }
 else if (is_dir($path)) {
 $success = rmdir($path);
 }
 else {
 $success = unlink($path);
 }
 if (!$success) {
 break;
 }
 }
 if ($success) {
 $success = rmdir($dirPath);
 }
 }
 if (!$success) {
 $this->setError(elFinder::ERROR_RM, $dirPath);
 return false;
 }
 return $success;
 }
 private static function listFilesInDirectory($dir, $omitSymlinks, $prefix = '') {
 if (!is_dir($dir)) {
 return false;
 }
 $excludes = array(".", "..");
 $result = array();
 $files = self::localScandir($dir);
 if (!$files) {
 return array();
 }
 foreach ($files as $file) {
 if (!in_array($file, $excludes)) {
 $path = $dir . DIRECTORY_SEPARATOR . $file;
 if (is_link($path)) {
 if ($omitSymlinks) {
 continue;
 }
 else {
 $result[] = $prefix . $file;
 }
 }
 else if (is_dir($path)) {
 $result[] = $prefix . $file . DIRECTORY_SEPARATOR;
 $subs = elFinderVolumeFTP::listFilesInDirectory($path, $omitSymlinks, $prefix . $file . DIRECTORY_SEPARATOR);
 if ($subs) {
 $result = array_merge($result, $subs);
 }
 }
 else {
 $result[] = $prefix . $file;
 }
 }
 }
 return $result;
 }
 }
 